/**
 * A question answerer is capable of answering queries (using the strategy
 * outlined in the ProfessionalMagician class's notes) of a specified type, such
 * as queries using the key word "is" ("who is" or "what is" queries).
 * <p>
 * THIS VERSION IS JUST A STUB (for use in testing ProfessionalMagician.java or
 * as a starting point for writing QuestionAnswerer.java.) As a working stub,
 * this contains ALL the public fields and methods of QuestionAnswerer. It also
 * contains one private member, a constant field to store your Google API Key.
 * The one currently used is the shared 111 key. You should replace it with your
 * own as soon as you have one. NO OTHER PRIVATE METHODS OR FIELDS ARE INCLUDED.
 * You will likely want to add some as you implement this class! Furthermore,
 * you will probably have to add an import statement to use SimpleGoogleSearch.
 * Check out the API for SimpleGoogleSearch to find out what package
 * SimpleGoogleSearch is in.
 */
public class QuestionAnswerer
{
    /**
     * The Google search key to use when accessing Google.
     * <p>
     * You should initialize this constant with the Google search key provided
     * to you!
     */
    private static final String KEY = "b2CVx0ZQFHJlbvQmy/qspJHAene+nCqu";

    /**
     * The maximum number of snippets from the list of Google search results to
     * consider in answering a query.
     * <p>
     * Setting this to a small number can reduce the time your program takes,
     * keep you under the search limit on your search key, and ease debugging.
     */
    public static final int MAX_SNIPPETS_TO_SEARCH = 4;

    /**
     * The maximum number of tiles to form from a given search result. For
     * example, if the query is "the tallest mountain in the world" and the
     * search result is "question anyway the tallest mountain in the world is
     * mount everest in the himalayas", the candidate tiles are "mount", "mount
     * everest", "mount everest in", "mount everest in the", and "mount everest
     * in the himalayas". If the maximum number of tiles to form is 3, the
     * QuestionAnswerer would stop considering tiles after "mount everest in".
     * <p>
     * Setting this to a small number can reduce the time your program takes,
     * keep you under the search limit on your search key, and ease debugging.
     */
    public static final int MAX_TILES_TO_FORM = 3;

    /**
     * Construct a QuestionAnswerer that focuses on the given key word.
     * 
     * @param keyWord the word to use after search phrases initially and before
     *        them in verification (non-null)
     */
    public QuestionAnswerer( String keyWord )
    {
        // TODO
    }

    /**
     * Get the key word associated with this QuestionAnswerer.
     * 
     * @return the key word
     */
    public String getKeyWord()
    {
        // TODO
        return null;
    }

    /**
     * Answer the given query from the user. If no answer can be found, this
     * method returns null to signal the failure.
     * 
     * @param query the user's query (non-null)
     * @return the best answer to the user's query OR null if no answer can be
     *         found
     */
    public String answer( String query )
    {
        // TODO
        // This method is just a stub that returns the query given.
        // Notice that you can test a COMPLETE version of
        // ProfessionalMagician.java using this stub of QuestionAnswerer.java,
        // without using either of the other two classes you have to write for
        // this assignment and without using SimpleGoogleSearch.
        //
        // To really thoroughly test ProfessionalMagician.java, try changing
        // this stub so that it can return null. Here's some example code that
        // lets you do that flexibly:
        //
        //Scanner scan = new Scanner(System.in);
        //System.out.println("Someone is trying to answer the query: " + query);
        //System.out.println("What answer would you like to give them?");
        //System.out.println("Note: if you enter null as the answer, this method");
        //System.out.println("will ACTUALLY return null rather than \"null\".");
        //String response = scan.nextLine();
        //if (response.equals("null"))
        //  response = null;
        //return response;
        
        // One last note: be careful about how you use SimpleGoogleSearch. One
        // instance of SimpleGoogleSearch can only hold the results from one
        // search at a time. You may need to do a second search while still
        // holding on to the results from your first search. If each instance of
        // SimpleGoogleSearch can only store the results of one search at a
        // time, how can you simultaneously access two sets of search results?

        return query;
    }
}
